// %flair:license{
// This file is part of the Flair framework distributed under the
// CECILL-C License, Version 1.0.
// %flair:license}
//  created:    2016/09/02
//  filename:   GuiGcs.h
//
//  authors:    Thomas Fuhrmann
//              Copyright Heudiasyc UMR UTC/CNRS 7253
//
//  version:    $Id: $
//
//  purpose:    Implementation of GuiInterface, using sockets
//
//
/*********************************************************************/

#ifndef MAVPLANNER_GUI_GCS_H
#define MAVPLANNER_GUI_GCS_H

#include <string>

#include "GuiInterface.h"

#include "MavlinkUDP.h"

namespace flair {
namespace core {
  class FrameworkManager;
  class Socket;
}
}

class GuiGcs : public GuiInterface {
public:

  GuiGcs(const flair::core::FrameworkManager *parent, std::string name,
  		 std::string &outputAddress, int outputPort);
  ~GuiGcs();

protected:

  virtual void MissionStart();
  virtual void MissionStop();
  virtual void MissionResume();
  virtual void MissionSend();

  uint16_t MavCommandGet(const std::string& command) const;

private:
  flair::core::Socket *outputSocket;
  std::string outputAddress;
  int outputPort;

  MavlinkUDP* mavCom;
};

#endif // MAVPLANNER_GUI_GCS_H
